/* wagon-ESP-OSC
 *  un wagon radio-guidÃ©
 *  plateforme ESP8266 ESP-12
 *  commande moteur Olimex BB-L298
 *  protocole rÃ©seau OSC
 *  SNHack gepeto@du-libre.org
 *  Codes sous licences GPLV3
 */

/* projet LOCO-DOM
 *  Arduino 1.6.5-rc5 , esp 2.0.0 en json
 *  lib esp8266-OSC, EspSoftSerial
 *
 *  IP du rÃ©seau 192.168.0.x/24
 *  les loco sont de x= 81 a 91
 *  ports 9081
 * Connexions ESP-12 BBL-298
 * |-                |   ESP-12   |          |        -|
   |-                |      RST   |       TXD|        -|
   |LDR              | ADC        |       RXD|       - |
   |-                |CH_P        |    GPIO4 |  1 RFID |
   |4 BBL            |   GPIO16   |    GPIO5 |        -|
   |3 BBL            |   GPIO14   |    GPIO0 |        -|
   |led bleu2 BBL-298|   GPIO12   |    GPIO2 |        -|
   |led verte        |   GPIO13   |   GPIO15 |led rouge|
   |-                |   VCC 3V   |       GND|        -|
 * Avec NodeCu
 *  2   D4  GPIO 02
 *  3   D5  GPIO 14
 *  4   D6  GPIO 12
 * RFID TX
 *   D7  GPIO 13
 */
// WIFI
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <Ticker.h> // gestion des timer

#define TAILLE_PUCE 12
#define TAILLE_TABLEAU_PUCES 273 // 21 x 13
//MDNSResponder mdns;
// OSC
//#include <OSCBundle.h>
#include <OSCMessage.h>
#include <OSCBoards.h>

#define MONIT true
//port numbers for OSC
const unsigned int inPort = 9081;
//destination IP pour la trace OSC
IPAddress MonitIP(192, 168, 0, 99); // IP et port du moniteur
const unsigned int MonitPort = 9998; // suivi normal
IPAddress DebugIP(192, 168, 0, 123); // IP et port de debug
const unsigned int DebugPort = 9999;
WiFiUDP udpin;
WiFiUDP udpout;
//Ticker zou; // OSC envoi position
//Ticker init_rfid; // init port rfid
Ticker ticker_batterie; // verif tension
#include <ArduinoJson.h>
#include "FS.h"
// serial
#include <EspSoftSerialRx.h>
EspSoftSerialRx rfid;
const char* ssid     = "LOCOMO";
const char* password = "0123456789";
char* nomhost  = "LOCO-2"; // le nom iendra de l'ip
char* nomloco = "LOCO-"; // debut du nom de la loco
int noloco = 2; // no de la loco
char* OSCVar = "/LOCO-2";

// DHCP donc pas besoin
//IP
//IPAddress (192,168,IPC,IPD);
int IPC = 0;
int IPD = 82;

//Brochage
// Driver moteur - NodeCU
const int enA = 2;  //nodeCU D4
const int in1 = 12; //nodeCU D6
const int in2 = 14; //nodeCU D5
const int ENTREERFID = 13 ; //NodeCU D7

// Olimex ESP8266-DEV
// lecteur RFID
//const int ENTREERFID = 2 ;
//const int enA = 14;
//const int in1 = 13;
//const int in2 = 12;

// ESP8266 platine ESP-12
// lecteur RFID
//const int ENTREERFID = 2 ; //ESP12
//const int enA = 12;
//const int in1 = 14;
//const int in2 = 16;

int vitesse_mini = 50; // vaincre les frotements
int vitesse_actuelle = 0 ; // vitesse actuelle
int sens = 1;
uint32_t temps_boucle_total = 14000 ; // en milli seconde
uint32_t temps_a_faire = 0;
uint32_t temps_depart = 0;
uint32_t temps_inter = 0;
uint32_t temps_tot_puce = 0;
int rampe_mini = 20; // >0 AV <0 ARR
int rampe = 0;
const int nbr_max_de_puce = 21;
char buf0[] = "00000000000000000000";
char tag[TAILLE_PUCE + 1];
char tag2[TAILLE_PUCE + 1];
unsigned char val = 0x00;
int distance_entre_puce = 43 ; // cm
int distance_totale = 516 ; //cm
int nbr_de_puce = 10;
int no_puce_actuelle = 0;
int puce_a_trouver = 0;
int puce_derniere_lue = 0;
int tour = 0;
// tableau des puces rfid 20x12
//char TableauPuces[nbr_max_de_puce][TAILLE_PUCE] = {
char TableauPuces[nbr_max_de_puce][TAILLE_PUCE + 1] = {
  "999999999999", // puce 0 inexistante on commence a 1 pour json
  "0103FA187292", // 1
  "0103FA19E908", // 2
  "0103FA19fA1B", // 3
  "0103FA199475", // 4
  "0103FA1A6f8D", // 5
  "0103FA199475", // 6
  "0103FA1AE604", // 7
  "0103FA197A98", // 8
  "0103FA188262", // 9
  "0103FA186989", // 10
  "0103FA186999", // 11
  "0103FA186990", // 12
  "0103FA186991", // 13
  "0103FA186992", // 14
  "0103FA186993", // 15
  "0103FA186994", // 16
  "0103FA186995", // 17
  "999999999996", // 18
  "999999999997"  // 19
};
uint32_t TableauTemps[nbr_max_de_puce];// temps entre 2 puce a 1000
uint32_t TableauTemps400[nbr_max_de_puce]; // temps entre 2 puce a 400
int commande = 0; // no de la commande en cours


void rfid_port_init() { // re initialisation du port rfid les 10s
  Serial.println("init rfid");
  rfid.service();
}
void jesuisla() { // envoie OSC /msg if position vitesse
  OSCMessage zouzou(OSCVar);
  zouzou.add("cmd puce vits tps ");
  zouzou.add((int32_t)commande); // commande en cours
  zouzou.add((int32_t)no_puce_actuelle);
  zouzou.add((int32_t)vitesse_actuelle);
  zouzou.add((int32_t)(millis() / 1000));
  udpout.beginPacket(MonitIP, MonitPort);
  zouzou.send(udpout);
  udpout.endPacket();
  udpout.beginPacket(DebugIP, DebugPort);
  zouzou.send(udpout);
  udpout.endPacket();
  zouzou.empty(); // free space occupied by
}
bool MonitMsg(char debugbla[], int debugint) {
  sprintf(OSCVar, "/LOCO-%d/%s", noloco, debugbla);
  if (MONIT) Serial.println(OSCVar);
  OSCMessage envoi(OSCVar);
  //envoi.add(debugbla);
  envoi.add(debugint);

  udpout.beginPacket(MonitIP, MonitPort);
  envoi.send(udpout);
  udpout.endPacket();

  udpout.beginPacket(DebugIP, DebugPort);
  envoi.send(udpout);
  udpout.endPacket();
  envoi.empty();
}

void Verif_Tension() { // lit ADC pour voir si tension entre 9 et 12.5
  int Vbatterie = 0;
  Vbatterie = analogRead(A0);
  MonitMsg("VBATTERIE", Vbatterie);
  if (Vbatterie < 300) { // a voir ..
    //Vitesse_moteur(0, 0);
    MonitMsg("ERR/VBATTERIE", Vbatterie);
  }
}
int Lit_Serie() { //retourne rien sauf si puce lu
  strncpy(tag, buf0,  TAILLE_PUCE + 1);
  val = 0x00;
  if (rfid.read(val)) {
    //Serial.println(val, HEX );
    // on saute avec le start 0x02 et stop bit 0x03
    if (val == 0x02) { // debut de puce
      strncpy(tag, buf0,  TAILLE_PUCE + 1);
      for (int i = 0; i <= (TAILLE_PUCE + 1 ); i++) {
        rfid.read(val);
        Serial.print(i);
        Serial.println(val, HEX );        //
        tag[i] = (char)val;
      }
      tag[TAILLE_PUCE] = '\0'; // on ferme ici
      MonitMsg(tag, 101);
      if (MONIT) Serial.print("tag: ");
      if (MONIT) Serial.println(tag);
      rfid.read(val) ; //flush
      rfid.read(val) ; //flush
      return (0);
    }
  }
  return (1);
}
int Lit_Serie_Attente() { // en attente du puce
  strncpy(tag2, buf0,  TAILLE_PUCE + 1);
  int j = 0;
  int k = 0;
  while ( true ) { // tant que pas de demande de stop??
    val = 0x00;
    if (rfid.read(val)) {
      //Serial.print(j);
      //Serial.println(val, HEX );
      if ( val != 0x02 && val != 0x03 ) {
        ; // on saute le start 0x02
        tag2[j] = (char)val;
        if (j == TAILLE_PUCE - 1 ) { // si complet ou stop bit 0x03
          tag2[TAILLE_PUCE ] = '\0'; // on ferme ici
          MonitMsg(tag2, 100);
          if (MONIT) Serial.print("tag ");
          if (MONIT) Serial.println(tag2);
          rfid.read(val) ; //flush
          rfid.read(val) ; //flush
          return (0);
        }
        j++;
      }
    }
    delay(20);
  }
}
int Lit_rfid() {
  // mise en forme de la lecture rfid
  //retourne le no_puce
  //Serial.println("attente rfid");
  int i = 0;
  strncpy( tag, buf0, TAILLE_PUCE + 1);
  for (i = 0; i <= (TAILLE_PUCE - 1); i++) {
    val = 0x00;
    if (rfid.read(val)) {
      tag[i] = '\0'; // Null
      // on saute avec le start 0x02 et stop bit 0x03
      if ( (val == 0x03) || (val == 0x02)) {
        break;
      }
      //      Serial.print(i);
      //      Serial.print(" ");
      //      Serial.print((char)val);
      //      Serial.print(" ");
      //    Serial.println(val, HEX );
      tag[i] = (char)val;

      if (i == (TAILLE_PUCE - 1) ) { // 11 digit read is complete
        tag[TAILLE_PUCE] = '\0'; // Null on ferme la chaine
        if (MONIT) Serial.print(tag);
        for (i = 1; i <= nbr_de_puce; i++) {
          if (strcmp(tag, TableauPuces[i]) == 0) {
            puce_derniere_lue =  i;
            if (MONIT) Serial.println(" ");
            if (MONIT) Serial.println(i);
            MonitMsg("puce ", puce_derniere_lue);
            //MonitMsg(tag,puce_derniere_lue);
            if (MONIT) Serial.println(tag);
            return (0);
          }
        }
        MonitMsg("puce inconnue ", 999);
        MonitMsg(tag, 999);
        return (99);

      }
    }
  }
  return (1);
}
int Lit_rfid2() {
  // mise en forme de la lecture rfid
  //retourne le no_puce venant du tableau
  if (Lit_Serie() == 0 ) {
    for (int i = 1; i <= nbr_de_puce; i++) {
      if (strcmp(tag, TableauPuces[i]) == 0) {
        puce_derniere_lue =  i;
        if (MONIT) Serial.println(" ");
        if (MONIT) Serial.println(i);
        MonitMsg("PUCE", puce_derniere_lue);
        if (MONIT) Serial.println(tag);
        return (0);
      }
    }
    MonitMsg("ERR/PUCEINCONNUE", 999);
    MonitMsg(tag, 999);
    return (999);
  }
  return (100);
}

bool MonitOSC(char debugbla[], int debugint) {
  OSCMessage envoi(debugbla);
  envoi.add(debugint);

  udpout.beginPacket(MonitIP, MonitPort);
  envoi.send(udpout);
  udpout.endPacket();

  udpout.beginPacket(DebugIP, DebugPort);
  envoi.send(udpout);
  udpout.endPacket();
  envoi.empty();
}
int Vitesse_moteur(int moteur, int accel) {
  int i = 0;
  if (moteur == 0 && accel == 0) { //arret brutale
    analogWrite(enA, 0);
    vitesse_actuelle = 0;
    return (0);
  }
  moteur = abs(moteur);
  if (moteur > 1024) // filtre le max
    moteur = 1024;
  if (moteur < vitesse_mini && moteur > 0) {
    moteur = vitesse_mini;
    MonitMsg("MOTEUR/VITESSE_MINI", vitesse_mini);
  }
  MonitMsg("MOTEUR/VITESSE", moteur);
  if (MONIT) Serial.println("vitesse ");
  if (MONIT) Serial.print(moteur);
  if (MONIT) Serial.println(" acel ");
  if (MONIT) Serial.println(accel);
  if ( accel < 0 ) {
    sens = -1;
    moteur = -moteur; // ARRIERE
  } else {
    sens = 1;
  }
  accel = abs(accel);
  if ( accel > 500 || accel < rampe_mini ) accel = rampe_mini;
  // en dessous de 20 ca plante !!
  // sinon on garde accel donne
  if (vitesse_actuelle > moteur) {
    for (i = vitesse_actuelle; i >= moteur; i = i - 20) {
      if ( i >= 0 ) {
        //Avant;
        digitalWrite(in1, LOW);
        digitalWrite(in2, HIGH);
      } else {
        //Arriere;
        digitalWrite(in1, HIGH);
        digitalWrite(in2, LOW);
      }
      analogWrite(enA, abs(i));
      delay(accel); // rampe
      //if (MONIT) Serial.println(i);
    }
  } else {
    for ( i = vitesse_actuelle; i <= moteur; i = i + 20) {
      if ( i >= 0 ) {
        //Avant;
        digitalWrite(in1, LOW);
        digitalWrite(in2, HIGH);
      } else {
        //Arriere;
        digitalWrite(in1, HIGH);
        digitalWrite(in2, LOW);
      }
      analogWrite(enA, abs(i));
      delay(accel); // rampe
      //if (MONIT) Serial.println(i);
    }
  }
  vitesse_actuelle = moteur;
  //analogWrite(enA, moteur);
  return (0);
}
// COMMANDES
void ArretMoteur(OSCMessage &msg) {
  commande = 0;
  Serial.println("ArretMoteur /stop");
  MonitMsg("STOP", 0);
  analogWrite(enA, 0);
  vitesse_actuelle = 0;
}
void MoteurControl(OSCMessage &msg) {
  // met le moteur Ã  la vitesse reÃ§ue, accel
  //commande = 1; ne change pas l'ordre en cours
  Serial.println("/moteur");
  Vitesse_moteur(msg.getInt(0), msg.getInt(1));
}

// remplir tableau avec les puces présentées au lecteur
// /inittableaupuce i nbr_de_puce
//
void InitTableauPuces1par1(OSCMessage &msg) {
  int i = 0;
  int puce = 0;
  char *buf[TAILLE_PUCE];
  Serial.println("/inittableaupuce");
  commande = 7;
  if (msg.getInt(0) > 0) {
    nbr_de_puce = abs((int) msg.getInt(0));
  } else {
    nbr_de_puce = nbr_max_de_puce;
  }
  Serial.println(nbr_de_puce);
  MonitMsg("INIT/TABLEAU/Tableau", nbr_de_puce);
  // tour pour nbr de puce total
  MonitMsg("INIT/TABLEAU/ATTENTE/PUCE1", 0 );
  while (Lit_Serie() != 0) {
    Serial.println("puce ? 1 ");
    delay(2000);
  }
  Serial.println(tag);
  strncpy( TableauPuces[1], tag,   TAILLE_PUCE);
  MonitMsg(TableauPuces[1], 1);
  MonitMsg("INIT/TABLEAU/ATTENTE/PUCES", nbr_de_puce );
  for (puce = 2; puce <= nbr_de_puce; puce++) { // On doit dÃ©jÃ  connaitre la puce 1
    while (Lit_Serie() != 0) {
      Serial.print("puce? ");
      Serial.print(puce);
      delay(2000);
      Serial.println(" :");
    }
    if (strcmp(tag, TableauPuces[1]) == 0 ) {
      nbr_de_puce = puce;
      break;
    }
    strncpy( TableauPuces[puce], tag,  TAILLE_PUCE) ;
    Serial.print(tag);
    Serial.print(" ");
    Serial.println(puce);
    MonitMsg(tag, puce );
  }
  Serial.print  ("nbr de puce ok ");
  Serial.println(puce);
  MonitMsg("INIT/TABLEAU/OK", puce);
  Vitesse_moteur(0, 0);
}
//
// Récupere la config de la flash
//
int Reprendre_config() {
  if (!SPIFFS.begin()) {
    if (MONIT) Serial.println("Failed to mount file system");
  }
  File configFile = SPIFFS.open("/config.json", "r");
  if (!configFile) {
    if (MONIT) Serial.println("pb de lecture de /config.json");
    nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
  } else {
    size_t size = configFile.size();
    if (size > 1024) {
      if (MONIT) Serial.println("Config file size is too large");
      return 3;
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);

    // We don't use String here because ArduinoJson library requires the input
    // buffer to be mutable. If you don't use ArduinoJson, you may as well
    // use configFile.readString instead.
    configFile.readBytes(buf.get(), size);

    StaticJsonBuffer<400> jsonBuffer;
    JsonObject& circuit = jsonBuffer.parseObject(buf.get());
    //circuit.printTo(Serial);
    if (!circuit.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /config.json");
      MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
      return (1);
    }

    if ( circuit["nbr_de_puce"] > 3)          nbr_de_puce = circuit["nbr_de_puce"];
    else nbr_de_puce = nbr_max_de_puce;
    if (circuit["distance_entre_puce"] > 10)   distance_entre_puce = circuit["distance_entre_puce"] ;
    if (circuit["distance_totale"]     > 300)  distance_totale     = circuit["distance_totale"];
    if (circuit["temps_boucle_total"]  > 5000) temps_boucle_total  = circuit["temps_boucle_total"];
    if (circuit["vitesse_mini"]        > 100)  vitesse_mini        = circuit["vitesse_mini"];
    if (MONIT) Serial.println(nomloco); // vient du setup ip[3] donne nom LOCO-..
    if (MONIT) Serial.println(nbr_de_puce);
    if (MONIT) Serial.println(distance_entre_puce);
    if (MONIT) Serial.println(distance_totale);
    if (MONIT) Serial.println(temps_boucle_total);
    if (MONIT) Serial.println(vitesse_mini);
    MonitMsg(nomloco, 0);
    delay(20);
    MonitMsg("FLASH/CONF/NBR_PUCE", nbr_de_puce);
    delay(20);
    MonitMsg("FLASH/CONF/distance_entre_puce", distance_entre_puce);
    delay(20);
    MonitMsg("FLASH/CONF/distance_totale", distance_totale);
    delay(20);
    MonitMsg("FLASH/CONF/temps_boucle_total", temps_boucle_total);
    delay(20);
    MonitMsg("FLASH/CONF/vitesse_mini", vitesse_mini);
    if (nbr_de_puce > 0) {
      for ( int i = 0; i < nbr_de_puce; i++) {
        if (circuit["tablepuces"][i]) {
          strncpy(TableauPuces[i + 1], circuit["tablepuces"][i], TAILLE_PUCE);
          if (MONIT) Serial.print(TableauPuces[i + 1]);
          if (MONIT) Serial.print(" puce:");
          if (MONIT) Serial.println(i + 1);
          MonitMsg(TableauPuces[i + 1] , i + 1);
          delay(20);
        }
        else {
          if (MONIT) Serial.println("reinit ");
          MonitMsg("FLASH/CONF/ERR/RESETCONF", nbr_de_puce);
          FlashTableauPuces();
          break;
        }
      }
    }
  }
  if (MONIT) Serial.println(" ");
  configFile.close();
  return (0);
}

void DonneFlash(OSCMessage & msg) {
  // commande = 13; transparente
  File configFile = SPIFFS.open("/config.json", "r");
  if (!configFile) {
    if (MONIT) Serial.println("pb de lecture de /config.json");
  } else {
    size_t size = configFile.size();
    if (size > 1024) {
      if (MONIT) Serial.println("Config file size is too large");
    }
    std::unique_ptr<char[]> buf2(new char[size]);
    configFile.readBytes(buf2.get(), size);
    StaticJsonBuffer<400> jsonBuffer;
    JsonObject& circuit = jsonBuffer.parseObject(buf2.get());
    if (!circuit.success()) {
      if (MONIT) Serial.println("donneflash parse pb de lecture de /config.json");
    }
    else {
      MonitMsg(nomloco, 0);
      //MonitMsg("IPD", circuit["IPD"]);
      delay(20);
      MonitMsg("FLASH/DONNE/nbr_de_puce", circuit["nbr_de_puce"]);
      delay(20);
      MonitMsg("FLASH/DONNE/distance_entre_puce", circuit["distance_entre_puce"]);
      delay(20);
      MonitMsg("FLASH/DONNE/distance_totale", circuit["distance_totale"]);
      delay(20);
      MonitMsg("FLASH/DONNE/temps_boucle_total", circuit["temps_boucle_total"]);
      delay(20);
      MonitMsg("FLASH/DONNE/vitesse_mini", circuit["vitesse_mini"]);
      if (MONIT) circuit.printTo(Serial);
      if (MONIT) Serial.println("");
      for (int i = 0; i < nbr_de_puce; i++) {
        strncpy(tag, circuit["tablepuces"][i], TAILLE_PUCE);
        MonitMsg(tag, i + 1);
        delay(20);
      }
      configFile.close();
    }
  }
}
//
// Sauvegarde des parametres dans la flash
//

/*
 * void EnvoiFlash(OSCMessage & msg) {
  //commande = 8; transparente
  StaticJsonBuffer<400> jsonBuffer;
  //JsonObject& circuit = jsonBuffer.createObject();
  msg.getString(0,jsonBuffer,msg.size);
  if (MONIT) Serial.println("sauvegarde config.json ");
  if (FlashTableauPuces() == 0) {
    if (MONIT) Serial.println("config.json sauvé");
    MonitMsg("sauveflash config.json ok", nbr_de_puce);
  }
}
*/
int FlashTableauPuces() {
  if (MONIT) Serial.println("go config.json ");
  StaticJsonBuffer<400> jsonBuffer;
  JsonObject& circuit = jsonBuffer.createObject();
  circuit["nom"] = WiFi.hostname();
  circuit["IPD"] = IPD;
  circuit["nbr_de_puce"]         = nbr_de_puce;
  circuit["distance_entre_puce"] = distance_entre_puce ;
  circuit["distance_totale"]     = distance_totale;
  circuit["temps_boucle_total"]  = temps_boucle_total;
  circuit["vitesse_mini"]        =  vitesse_mini ;
  JsonArray& puces = circuit.createNestedArray("tablepuces");
  for (int i = 0; i < nbr_de_puce; i++) {
    puces.add( TableauPuces[i + 1]);
  }
  File configFile = SPIFFS.open("/config.json", "w");
  if (!configFile) {
    if (MONIT) Serial.println("Failed to open config file for writing");
    MonitMsg("FLASH/ERR/ECRITURE", nbr_de_puce);
    return (2);
  }
  circuit.printTo(configFile);
  MonitMsg("FLASH/OK", nbr_de_puce);
  circuit.printTo(Serial);
  configFile.close();
  return (0);
}
void SauveFlash(OSCMessage & msg) {
  //commande = 8; transparente
  if (nbr_de_puce == 0) nbr_de_puce = msg.getInt(0);
  if (MONIT) Serial.println("sauvegarde config.json ");
  if (FlashTableauPuces() == 0) {
    if (MONIT) Serial.println("config.json sauvé");
    MonitMsg("FLASH/SAUVEGARDE/OK", nbr_de_puce);
  }
}
void SauveEcart(OSCMessage & msg) {
  if (msg.getInt(0) > 0) {
    distance_entre_puce = msg.getInt(0);
    FlashTableauPuces();
  }
}
void SauveNbrPuce(OSCMessage & msg) {
  if (msg.getInt(0) > 5) {
    nbr_de_puce = msg.getInt(0);
    FlashTableauPuces();
  }
}

void SauveIPD(OSCMessage & msg) {
  if (msg.getInt(0) > 0) {
    IPD = msg.getInt(0);
    if (IPD > 80 && IPD < 90) {
      Serial.println(IPD);
      Serial.println("flash et reboot");
      MonitMsg("FLASH/OK/REBOOT", nbr_de_puce);
      FlashTableauPuces();
      delay(2000);
      ESP.restart();
    }
  }
}
void SauveTempstot(OSCMessage & msg) {
  if (msg.getInt(0) > 0) {
    temps_boucle_total = msg.getInt(0);
    FlashTableauPuces();
  }
}
void SauveVitessemini(OSCMessage & msg) {
  if (msg.getInt(0) > 0) {
    vitesse_mini = msg.getInt(0);
    FlashTableauPuces();
  }
}
void SauveDisttot(OSCMessage & msg) {
  if (msg.getInt(0) > 0) {
    distance_totale = msg.getInt(0);
    FlashTableauPuces();
  }
}
//
// Initialisation totale
//
void Initialisation_Tableau(OSCMessage & msg) {
  // Placer la loco juste avant la puce qui sera la 1
  // la loco fait un tour complet doucement pour connaitre les puces
  int i = 0;
  int puce = 0;
  commande = 2;
  val = 0x00;
  char tagavant[TAILLE_PUCE + 1] = "";
  //zou.detach();
  if (msg.getInt(0) > 0) {
    nbr_de_puce = abs((int) msg.getInt(0));
    if (MONIT) Serial.print("/init");
    if (MONIT) Serial.println(nbr_de_puce);
    MonitMsg("INIT", nbr_de_puce);
    Vitesse_moteur(800, 0);
    uint32_t temps = (uint32_t)millis();
    strncpy( TableauPuces[1], buf0,  TAILLE_PUCE) ;
    for (puce = 1; puce <= nbr_de_puce; puce++) {
      temps = (uint32_t)millis();
      while (Lit_Serie() != 0) delay(20);
      MonitMsg("INIT/PUCE", puce);

      if (strncmp(TableauPuces[1], tag, TAILLE_PUCE) == 0  && puce >= 3) { // puce 1 avant fin presumee
        nbr_de_puce = puce - 1;
        if (MONIT) Serial.println("puce 1 donc fin avant ");
        break;
      }

      if ( strncmp(tagavant, tag, TAILLE_PUCE) == 0 ) { // si pas meme puce lue 2 fois
        MonitMsg("INIT/PUCELUEIDEM", puce);
        puce--; // une boucle pour rien
      } else {
        strncpy( TableauPuces[puce], tag,  TAILLE_PUCE) ;
        strncpy( tagavant, tag,  TAILLE_PUCE) ;
        TableauTemps400[puce] =  (uint32_t)millis() - temps;
        if (MONIT) Serial.print("puce ");
        if (MONIT) Serial.print(TableauPuces[puce]);
        if (MONIT) Serial.print(" no ");
        if (MONIT) Serial.println(puce);
        MonitMsg("INIT/PUCELUEOK", puce);
        //MonitMsg(TableauPuces[puce], 0);
      }
      strncpy(tag, buf0,  TAILLE_PUCE) ;
      delay(3000); // pour ne pas lire la meme puce
    }
    MonitMsg("INIT/NBRPUCEOK", nbr_de_puce);
    Vitesse_moteur(0, 0);
    FlashTableauPuces();
  }
}
void Initialisation_Vitesse(OSCMessage & msg) {
  // on demare sur la 1
  Aller(1, 1000, 0); // on va juste avant puce 1
  Aller(1, 800, -20); // on va juste avant puce 1
  //rouler a fond
  // puce 1 declenche timer
  Aller(1, 1100, 0);
  uint32_t temps = (uint32_t)millis();
  temps_depart = temps;
  if (MONIT) Serial.println("calcul temps ");
  if (MONIT) Serial.println(temps_depart);
  MonitMsg("INIT/TEMPS/DEPART", temps_depart);
  // vue la vitesse pas de pb de double lecture rfid
  for (puce = 2; puce <= nbr_de_puce; puce++) {
    while (Lit_rfid() != 0) delay (20); // boucle en attente de puce
    if (puce_derniere_lue != 1 ) {
      TableauTemps[puce] = (uint32_t)millis() - temps;
      //MonitMsg("INIT/PUCE_DERNIERE_LUE", puce);
      MonitMsg("INIT/TEMPS/", TableauTemps[puce]);
    }
    temps_boucle_total = (uint32_t)millis() - temps_depart ; // gaff au temp de lecture
    // enregistrer les parametres
    //Serial.print("temps ");
    //Serial.print(temps_boucle_total);
    //zou.attach(5, jesuisla);
    MonitMsg("INIT/TEMPS_BOUCLE_TOTAL", temps_boucle_total );
    if (MONIT) Serial.println("temps_boucle_total ");
    if (MONIT) Serial.println(temps_boucle_total);
    FlashTableauPuces(); // on a deja les puces ...
    commande = 0;
    Vitesse_moteur(0, 0);
  }
  //
  // GOTO iii puce temps acceleration
  //
  void Rendezvous(OSCMessage & msg) {
    // /goto iii puce temps rampe : se rendre a la puce xx en tant de temps
    commande = 3;
    int distance = 0;
    float vitesse = 0;
    int puce = 0;
    puce_a_trouver = (int) msg.getInt(0);
    if (puce_a_trouver == 0 || puce_a_trouver > nbr_de_puce) {
      MonitMsg("GOTO/ERR/PASDEPUCE", puce_a_trouver);
    } else {
      temps_a_faire = (uint32_t)msg.getInt(1) ;
      if (temps_a_faire > 900000) {
        MonitMsg("GOTO/ERR/TEMPSTROPLONG", temps_a_faire);
      } else {

        rampe = (int) msg.getInt(2); // si <0 alors marche arriere
        if ( rampe < 0 ) {
          sens = -1;
        } else {
          sens = 1;
        }
        if (puce_derniere_lue == 0  ||  puce_derniere_lue > 90  ) { // on ne connait pas la puce depart
          if (MONIT) Serial.print("/rdv cherche puce ");
          if (MONIT) Serial.println(puce_derniere_lue);
          MonitMsg("GOTO/ATTENTE_PUCE", 390);
          Vitesse_moteur(800, 0);
          while (Lit_rfid() >= 90 || puce_derniere_lue == 0  ) // on cherche la prochaine, renseigne puce_derniere_lue
            delay(200);
          no_puce_actuelle = puce_derniere_lue;
        }
        MonitMsg("GOTO/PUCE_DEPART", no_puce_actuelle );
        if (MONIT) Serial.print("/rdv de ");
        if (MONIT) Serial.print(puce_derniere_lue);
        if (MONIT) Serial.print(" a trouver ");
        if (MONIT) Serial.println(puce_a_trouver);
        temps_depart = (uint32_t)millis();
        temps_tot_puce = temps_depart;
        // 1 vitesse constante sur le trajet sauf accel
        // v= vitess max / (Dtot/Ttot)*t/d
        // puce devant plus grande
        if ((puce_a_trouver > puce_derniere_lue) && rampe >= 0) {
          distance = (puce_a_trouver - puce_derniere_lue) * distance_entre_puce;
        } else {
          if ((puce_a_trouver < puce_derniere_lue) && rampe >= 0) {
            // puce devant plus petite et marche avant
            distance = (puce_a_trouver - puce_derniere_lue + nbr_de_puce ) * distance_entre_puce;
          } else {
            if ((puce_a_trouver > puce_derniere_lue) && rampe < 0) { //arriere
              distance = (nbr_de_puce - puce_a_trouver - puce_derniere_lue) * distance_entre_puce;
            } else {
              if ((puce_a_trouver < puce_derniere_lue) && rampe < 0) { //arriere
                distance = (puce_derniere_lue - puce_a_trouver) * distance_entre_puce;

              } else {
                if ((puce_a_trouver == puce_derniere_lue)) { //si meme puce alors un tour complet
                  distance = distance_totale;
                  tour += 2;
                  if (MONIT) Serial.println("tour + 2");
                  MonitMsg("GOTO/TOUR/1", tour);
                }
              }
            }
          }
        }
        MonitMsg("GOTO/DISTANCE_A_FAIRE", distance);
        if (distance == 0) {
          distance = distance_totale;
        }
        vitesse =  ((float)distance_totale / (float)temps_boucle_total) * ((float)temps_a_faire / (float)distance);
        vitesse = 1000 / vitesse;
        if (vitesse > 1010) {
          MonitMsg("GOTO/ERR/TEMPS_TROP_COURT", temps_boucle_total );
          vitesse = 1000;
        }
        if (vitesse < vitesse_mini) {
          MonitMsg("GOTO/ERR/TEMPS_TROP_LONG", 0 );
          vitesse = vitesse_mini;
        }
        if (MONIT) Serial.println(vitesse);
        MonitMsg("GOTO/DISTANCE", distance);
        delay(20);
        MonitMsg("GOTO/VITESSE", (int) vitesse);
        temps_depart = (uint32_t)millis();
        Vitesse_moteur((int)vitesse, rampe); // on roule , pendant un certain temps
      }
    }
  }
  //
  // / aller iii puce vitesse acceleration

  bool Aller(int no_puce, int vitesse, int accel) {
    // aller jusqu'a la puce no_puce a vitesse
    Serial.println("Aller");
    MonitMsg("ALLER", no_puce);
    puce_a_trouver = no_puce;
    if (puce_a_trouver == 0 || puce_a_trouver > nbr_de_puce) {
      MonitMsg("ALLER/ERR/PASDEPUCE", puce_a_trouver);
    } else {
      temps_depart = (uint32_t)millis();
      temps_tot_puce = temps_depart;
      rampe = accel;
      Vitesse_moteur(vitesse, accel);
      if ((puce_a_trouver == puce_derniere_lue)) { //si meme puce alors un tour complet
        tour  += 1;
        if (MONIT) Serial.println("tour + 1");
        MonitMsg("ALLER/TOURPLUS1", tour);
      }
      return (true);
    }
    return (false);
  }
  //
  void SeRendre(OSCMessage & msg) {
    // /aller ii puce vitesse : se rendre a la puce xx a n vitesse [acceleration]
    commande = 4;
    Aller((int)msg.getInt(0), (int)msg.getInt(1), (int)msg.getInt(2) );
  }
  void LitPuce(OSCMessage & msg) {
    commande = 6;
    Serial.println("lit");
    //zou.detach();
    while (Lit_Serie() != 0) delay(20);
  }

  void Ou(OSCMessage & msg) {
    // commande = 9; transparente
    //Serial.println("ou");
    //zou.attach(5, jesuisla);
    MonitMsg("PUCE/DERNIERE_LUE", puce_derniere_lue);
  }
  void Recup_Tension(OSCMessage & msg) {
    Verif_Tension();
  }
  //
  //
  void setup()
  {
    Serial.begin(115200);
    // set all the motor control pins to outputs
    pinMode(enA, OUTPUT);
    pinMode(in1, OUTPUT);
    pinMode(in2, OUTPUT);
    //digitalWrite(in1, LOW);
    //digitalWrite(in2, LOW);
    //digitalWrite(enA, LOW);
    // serial RFID
    rfid.begin(9600, ENTREERFID); //
    Serial.println(ESP.getChipId(), HEX);
    //setup ethernet part
    Serial.println();
    Serial.print("Connecting to ");
    Serial.println(ssid);
    WiFi.mode(WIFI_STA);
    //WiFi.hostname(nomhost);
    WiFi.begin(ssid, password);
    while (WiFi.status() != WL_CONNECTED) {
      delay(500);
      Serial.print(".");
    }
    //  DHCP donc pas fixÃ© ici
    //WiFi.config(IPAddress(192, 168, IPC, IPD), IPAddress(192, 168, IPC, IPD), IPAddress(255, 255, 255, 0));
    Serial.println("");
    Serial.println("WiFi connected");
    Serial.println(ssid);
    Serial.println("IP address: ");
    IPAddress IPLOCAL = WiFi.localIP();
    IPD = (int)IPLOCAL[3];
    Serial.println(IPD);
    //Serial.println(WiFi.macAddress);
    noloco = abs(IPD - 80);
    sprintf(nomloco, "LOCO-%d", noloco);
    sprintf(OSCVar, "/LOCO-%d", noloco);
    Serial.println("hostname: ");
    Serial.println(nomloco);
    WiFi.hostname(nomloco);
    Serial.println(WiFi.hostname());
    Serial.println("Starting UDP");
    udpin.begin(inPort);
    Serial.print("Local port: ");
    Serial.println(udpin.localPort());

    delay(100);
    // envoi le bonjour
    MonitMsg("BONJOUR", (int32_t)ESP.getChipId());
    //recupere le s puce du fichier /puces.buf
    Reprendre_config();

    // verifier toutes les minute la batterie
    //ticker_batterie.attach(60, Verif_Tension);

    // placer jesuisla en boucle timer 1s
    //zou.attach(5, jesuisla);
    // init_rfid.attach(10, rfid_port_init); ?
    /*
    digitalWrite(in1, LOW);
    digitalWrite(in2, HIGH);
    analogWrite(enA, 500);
    delay(2000);
    analogWrite(enA, 700);
    delay(2000);
    analogWrite(enA, 900);
    */

  }
  //
  void loop()
  {
    // Lire la comande et executer le debut
    OSCMessage msgIN;
    int size;
    char puce_char[] = "  ";
    if ( (size = udpin.parsePacket()) > 0)
    {
      while (size--)
        msgIN.fill(udpin.read());

      if (!msgIN.hasError()) {
        // /stop immediat moteur et commande
        msgIN.dispatch("/stop", ArretMoteur);  // commande=0

        // /moteur ii vitesse +/- rampe (av/arr)
        //        rampe  <0 : marche arriere, 0 brutal
        msgIN.dispatch("/moteur", MoteurControl); //  commande=1 n cmd transparente

        // /init fait un tour pour decouvrir les puces, le parcours distance_totale et temps_boucle_totale
        msgIN.dispatch("/inittableau", Initialisation_Tableau);  // commande=2

        // /init fait un tour pour temps_boucle_totale
        msgIN.dispatch("/initvitesse", Initialisation_Vitesse);  // commande=19

        // /goto iii puce temps(ms) +/-rampe (av/arr) va Ã  la puce dans le temps donnÃ©
        msgIN.dispatch("/goto", Rendezvous);      // commande=3

        // /aller iii puce vitesse rampe
        msgIN.dispatch("/aller", SeRendre);       // commande=4

        // /lit renvoi le code de la derniere puce lue
        msgIN.dispatch("/lit", LitPuce);          //   commande=6

        // /puces rempli le tableau avec les puce presentees devant la boucle a larret
        msgIN.dispatch("/puces", InitTableauPuces1par1);  // commande=7

        // /sauvepuces enregistre le tableau dans la flash
        msgIN.dispatch("/sauveflash", SauveFlash); // commande=8
        // /donnepuces renvoi les données de la flash
        msgIN.dispatch("/donneflash", DonneFlash); // commande=13

        // /ou renvoi la derniere puce lu
        msgIN.dispatch("/ou", Ou);                //  commande=9

        // /sauveecart i distance_entre_puce, enregistre l'ecart entre les puce dans la flash
        msgIN.dispatch("/sauveecart", SauveEcart); // commande=11

        // /sauvetempstot i temps_boucle_totale, enregistre le tableau dans la flash
        msgIN.dispatch("/sauvetempstot", SauveTempstot); // commande=12

        // /sauveip i IPD change IPD, enregistre la flash et reboot  commande= 14
        msgIN.dispatch("/sauveip", SauveIPD); // commande=14

        // /sauvevitessemini i vitesse_mini enregistre la vitesse_mini
        msgIN.dispatch("/sauvevitessemini", SauveVitessemini); // commande=15

        // /sauvedisttot i distance_totale, enregistre
        msgIN.dispatch("/sauvedisttot", SauveDisttot); // commande=16

        // /sauvenbrpuce i nbr_de_puce, enregistre
        msgIN.dispatch("/sauvenbrpuce", SauveNbrPuce); // commande=17

        // /vbatterie // renvoi le temoin batterie
        msgIN.dispatch("/batterie", Recup_Tension); // commande=18
      }
      udpin.flush();
    }
    // Lire une puce et continuer une commande en cours
    if (commande != 0) {
      if (commande != 2 && commande != 7) {
        if (commande == 6) {
          Lit_Serie();
        } else {
          //puce_derniere_lue revient de Lit_rfid
          if (Lit_rfid() == 0) {
            sprintf(puce_char, "%d", puce_derniere_lue);
            //MonitOSC(puce_char, (uint32_t)millis());
            temps_inter = (uint32_t)millis() - temps_depart ;
            temps_tot_puce += temps_inter;
            //MonitMsg("temps ", temps_inter );
            //Serial.print("puce lue ");
            //Serial.print(puce_derniere_lue);
            //Serial.print(" a trouver ");
            //Serial.println(puce_a_trouver);
            if (commande == 3 && ( temps_a_faire + 3000 < ((uint32_t)millis() - temps_depart  ))) {// on laisse tomber a 3s rniere_lue);
              Vitesse_moteur(0, 0);
              MonitMsg("GOTO/ERR/TEMPS_PASSE" , puce_derniere_lue);
              commande = 0;
            }
            /*
            if (commande == 3 && (abs(vitesse_actuelle) > 800) && (temps_a_faire - ((uint32_t)millis() - temps_depart) < 1000 )) { // ralentir 1s avant
              vitesse_actuelle = vitesse_actuelle - (sens * 100);
              if (abs(vitesse_actuelle) < 0) vitesse_actuelle = 0;
              analogWrite(enA, vitesse_actuelle);
              MonitMsg("goto rallenti" , puce_derniere_lue);
            }

            if ( commande == 4 && abs(vitesse_actuelle) > 800 && ( (puce_derniere_lue == puce_a_trouver - 1 && rampe > 0) || (puce_derniere_lue == puce_a_trouver + 1 && rampe < 0) )) {
              vitesse_actuelle = vitesse_actuelle - (sens * 100);
              if (abs(vitesse_actuelle) < 0) vitesse_actuelle = 0;
              analogWrite(enA, vitesse_actuelle);
              MonitMsg("aller rallenti" , puce_derniere_lue);
            }
            */
            if (commande == 4 || commande == 3) {
              if ((( sens >= 0 && puce_derniere_lue >= puce_a_trouver ) || ( sens < 0 && puce_derniere_lue <= puce_a_trouver ) ) && tour <= 0) {
                //stopmoteur
                Vitesse_moteur(0, 0); //rampe a 0
                if (MONIT) Serial.println(" ok ");
                if (MONIT) Serial.println(tour);
                MonitMsg("GOTO/OK" , puce_derniere_lue);
                delay(20);
                MonitMsg("EN", (int) ((uint32_t)millis() - temps_depart) );
                temps_tot_puce = 0;
                no_puce_actuelle = puce_a_trouver;
                commande = 0;
              }
            }
            no_puce_actuelle = puce_derniere_lue;
            if (puce_derniere_lue == puce_a_trouver ) {
              tour -= 1;
              if (MONIT) Serial.println("tour --");
              MonitMsg("TOUR_MOINS_1" , tour);
            }
          }
        }
      }
      delay(30);
    }

  }
